#include <TMB.hpp>
/*
 * this file uses all the data, that is it can us as much data as we want, but it assmes that every teams strength is 
 * constant over time. It will only be used to make the computation of the browninan motion quicker. 
 */
template<class Type>
Type objective_function<Type>::operator() ()
{
  DATA_VECTOR(x);//the  home goals for all 12 seasons 
  DATA_VECTOR(y); // the away goals for all 12 sesons
  DATA_FACTOR(home); // home team, of the possible 38 teams
  DATA_FACTOR(away); // away teams
  DATA_INTEGER(nt); // the number of teams
  
  PARAMETER_VECTOR(a0); // attacking strength for the teams
  PARAMETER_VECTOR(d0); // defensive strength for the teams
  PARAMETER_VECTOR(log_sd);//the standad deviation for the random intercepts
  PARAMETER(c); // the constant 
  PARAMETER(ch);//the home field advantage
  
  
  Type nll = 0;//the negative log likelihood
  vector<Type> residual(2);//just a vector used later to hold values
  vector<Type> sd = exp(log_sd); // the standard deviation
  matrix<Type> Sigma(2, 2); // the varaincematrix for a,d
  Sigma.row(0) << sd[0]*sd[0],     sd[1]*sd[0]*0;//the varaince matrix, made diagonal
  Sigma.row(1) << sd[0]*sd[1]*0, sd[1]*sd[1];
  
  
  using namespace density;
  MVNORM_t<Type> neg_log_dmvnormI(Sigma);//a function that returns the negative log likelihood given a vector.
  for(int i = 0;i < nt;i++){
    residual[0] = a0[i];
    residual[1] = d0[i];
    nll += neg_log_dmvnormI(residual);//including all the random intercepts
  }
  
  
  
  // the poisson model
  for(int i = 0; i < x.size();i++){
    nll -= dpois(x[i],exp(a0[home[i]]-d0[away[i]]+c+ch),true);//the home score
    nll -= dpois(y[i],exp(a0[away[i]]-d0[home[i]]+c),true);//the away score
  }
  
  
  return nll;
}