#include <TMB.hpp>
/*
 * this model used the generalized bradle-Terry model to estimate the strength of the teams. It uses random intercept for the strength of the teams 
 */
template<class Type>
Type objective_function<Type>::operator() ()
{
  DATA_MATRIX(X);//the results of the match. Each row is one match. (1,0,0) is home victory.
  DATA_FACTOR(home); // the home team 0-19 in alphabitical order
  DATA_FACTOR(away); // the away teams
  
  PARAMETER(theta); 
  PARAMETER(h);
  PARAMETER_VECTOR(lam);
  PARAMETER(log_sigma);
  
  Type nll = 0;
  vector<Type> prob(3);
  vector<Type> res(3);
  
  nll -= sum(dnorm(lam,0,exp(log_sigma),true)); 
  
  for(int i = 0;i<home.size();i++ ){
    prob[0] = 1/(1+exp(-(lam[home[i]]-lam[away[i]]-theta+h)));
    prob[1] = 1/(1+exp(-(lam[home[i]]-lam[away[i]]+theta+h)))-1/(1+exp(-(lam[home[i]]-lam[away[i]]-theta+h)));
    prob[2] = 1-1/(1+exp(-(lam[home[i]]-lam[away[i]]+theta+h)));
    res = X.row(i);
    nll -= dmultinom(res,prob,true);
  }
  
  
  return nll;
}