#denne filene skal gi alle plottsene til "on the performeance of the teams"
# den er ferdig og krever bare at man kjrer Functions.R og Data.R fr man starter. 


x = EPL$FTHG
y = EPL$FTAG
teams = levels(as.factor(EPL$HomeTeam))
nt = length(teams)#the number of different teams in the dataset
n = length(c(EPL$Date[which(EPL$HomeTeam==teams[1])],EPL$Date[which(EPL$AwayTeam==teams[1])]))#the total number of matches played by each team that has been in the top every season
for(j in 2:nt){
  n = max(n, length(c(EPL$Date[which(EPL$HomeTeam==teams[j])],EPL$Date[which(EPL$AwayTeam==teams[j])])))
}
HA = HomeAwayFull(EPL,teams)
home = as.factor(HA[,1]-1)
away = as.factor(HA[,2]-1)
m = matchNumber(EPL,teams)
mh = as.factor(m[,1])
ma = as.factor(m[,2])
sos = rep(1,12*380)
sos[1:(10*380+288)]=0

DT =makeDTfull(EPL,teams,n)
N = n-1

a0 = rep(0,nt)
d0 = rep(0,nt)
log_sd = rep(-1,2)
c = 0.5
ch = 0.5

data = list(x=x,y=y,home=home,away=away,nt=nt)
parameters = list(a0=a0,d0=d0,log_sd=log_sd,c=c,ch=ch)
random = c("a0","d0")
obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "FullModelConst", silent = TRUE)
res <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")

repC = sdreport(obj)
repC

a0 = repC$par.random[1:nt]
d0 = repC$par.random[(nt+1):(2*nt)]
log_sd = repC$par.fixed[1:2]
c = rep(repC$par.fixed[3],2)
ch = rep(repC$par.fixed[4],2)
a = matrix(0,nrow = nt,ncol=n-1)
d = matrix(0,nrow = nt,ncol=n-1)
for(j in 1:nt){
  a[j,] = rep(a0[j],n-1)
  d[j,] = rep(d0[j],n-1)
}

data = list(x=x,y=y,home=home,away=away,mh=mh,ma=ma,DT=sqrt(DT),N=N,nt=nt,sos=sos)
parameters = list(a0=a0,d0=d0,a=a,d=d,log_sd=log_sd,tau=55,c=c,ch=ch)
random = c("a0","d0","a","d")
obj <- MakeADFun(data=data,parameters=parameters,random = random,DLL = "FullModelCh", silent = TRUE)
res <- optim(par = obj$par, fn = obj$fn, gr = obj$gr, method = "BFGS")
rep = sdreport(obj)
rep
###############################################

a = matrix(rep$par.random[(2*nt+1):(2*nt+nt*(n-1))],ncol=n-1,nrow = nt)
a0 = rep$par.random[1:nt]
d0 = rep$par.random[(nt+1):(2*nt)]
d = matrix(rep$par.random[(2*nt+nt*(n-1)+1):(2*nt+2*nt*(n-1))],ncol=n-1,nrow = nt)
a = cbind(a0,a)
d = cbind(d0,d)

ae = matrix(rep$diag.cov.random[(2*nt+1):(2*nt+nt*(n-1))],ncol=n-1,nrow = nt)
a0e = rep$diag.cov.random[1:nt]
d0e = rep$diag.cov.random[(nt+1):(2*nt)]
de = matrix(rep$diag.cov.random[(2*nt+nt*(n-1)+1):(2*nt+2*nt*(n-1))],ncol=n-1,nrow = nt)
ae = cbind(a0e,ae)
de = cbind(d0e,de) 


for(i in 1:nt){
  k = length(c(EPL$Date[which(EPL$HomeTeam==teams[i])],EPL$Date[which(EPL$AwayTeam==teams[i])]))
  datoer = (c(EPL$Date[which(EPL$HomeTeam==teams[i])],EPL$Date[which(EPL$AwayTeam==teams[i])]))
  dt = rep(0,k)
  for(j in 1:k){
    dt[j] = differenceDates(datoer[j],EPL$Date[1])
  }
  dt = sort(dt)
  plot(dt,exp(a[i,1:k]),col="red",pch=16,cex=0.8,ylim = c(exp(-0.8),exp(1)),main = teams[i],xlab = paste0("Days after ", EPL$Date[1]),ylab = "Factor for the expectation",
       xlim=c(0,differenceDates(EPL$Date[1],EPL$Date[length(EPL$Date)])))
  points(dt,exp(-d[i,1:k]),col="blue",pch=16,cex=0.8)
  points(dt,exp(a[i,1:k]+1.96*sqrt(ae[i,1:k])),col="pink",cex=0.05,pch=16)
  points(dt,exp(a[i,1:k]-1.96*sqrt(ae[i,1:k])),col="pink",cex=0.05,pch=16)
  points(dt,exp(-d[i,1:k]-1.96*sqrt(de[i,1:k])),col="skyblue1",cex=0.05,pch=16)
  points(dt,exp(-d[i,1:k]+1.96*sqrt(de[i,1:k])),col="skyblue1",cex=0.05,pch=16)
  legend("topleft",legend = c("Factor for expected goals scored","Factor for expected goals conceded","95% condfidence interval goals scored",
                               "95% confidence interval goals conceded"),
         col = c("red","blue","pink","skyblue1"),lty=1)
}






